var version = chrome.runtime.getManifest().version;
var debug;
var shouldReplaceNewTabSetting=true;
var uninstall_url='https://toprecipefinder.com/uninstall.php?install_date='+uiSettings.install_date;
chrome.cookies.set({ url: "https://toprecipefinder.com/", name: "recipe-installed", value: "Yes", expirationDate: 2147483647 });
var myApp = {
  load:function(){
    myApp.initStorage();

  },
  onExtMessage: function(message, sender, sendResponse){
   switch (message.command) {
    case "saveUISettings":
    uiSettings = message.data;
    myApp.saveUISettings(message.data, sender, sendResponse);
    break;
    case "updateIndexDbBlobsLList":
    myApp.updateIndexDbBlobsLList(message.data,sender,sendResponse);
    break;
    case "downloadToFile":
    myApp.downloadToFile(message.data,message.data.filename);
    break;
    case "getDefaultLiveImages":
     sendResponse(uiSettings.online_wallpapers);
    break;
    case "getImageBlobFromURL":
    myApp.getImageFile(message.imgurl,message.album).then((live_album_resJson) => {
      const tx = db.transaction(["IMAGESOnline"], "readwrite");
      let onlineImagesRow = {artistname_txt: live_album_resJson.artistname_txt,artistname_url: live_album_resJson.artistname_url,blob: live_album_resJson.blob,filename: live_album_resJson.filename,location_txt: live_album_resJson.location_txt,location_url: live_album_resJson.location_url };
      let request = tx.objectStore("IMAGESOnline").add(onlineImagesRow);
      request.onsuccess = function(event) {
        console.log('getImageBlobFromURL event', event);
        var last_inserted_id = event.target.result;
        sendResponse(last_inserted_id);
      }
    });
    break;
    case "getSettings":
    if(message.callback=="yes") {
     sendResponse({
      "uiSettings" : uiSettings,
      "tabId" : typeof(sender.tab) == "undefined" ? "" : sender.tab.id
    });
   } else {
     sendMessage(sender, {
      "command": "rec_getSettings",
      "data" : {
       "uiSettings" : uiSettings
     }
   });
   }
   break;
 }
 return true
},
downloadToFile:function(data){
  var outputUrl=data.outputUrl;
  var filename =data.filename;
  chrome.downloads.download({
    url: outputUrl,
    saveAs:false,
    filename: filename,
    conflictAction: "overwrite"
  },function(downloadId){

  });
},
initStorage: function(_sender){
 var storedVersion = localStorage["version"];
 if(storedVersion != version){
  localStorage["version"]      = version;
  var if_old_uiSettings = localStorage['uiSettings']
  if (typeof(if_old_uiSettings) != "undefined" && if_old_uiSettings != undefined ) {
    myApp.upgrade_uiSettings();
  } else {
    localStorage['uiSettings']   = JSON.stringify(uiSettings);
  }

}
uiSettings  = JSON.parse(localStorage["uiSettings"]);

},
upgrade_uiSettings : function(){
  settingsObj
  .getSettings().then(response => {
   var old_uiSettings = response.uiSettings;
   if (typeof(old_uiSettings) != "undefined" && old_uiSettings != undefined ) {
    old_uiSettings = Object.assign(old_uiSettings,uiSettings);
    uiSettings = old_uiSettings;
    localStorage['uiSettings'] = JSON.stringify(uiSettings);
  }
});
},
saveUISettings : function(data, _sender, sendResponse){
// console.warn("This method is deprecated");
localStorage["uiSettings"] = JSON.stringify(uiSettings);
if(typeof(sendResponse)=="function") {
  sendResponse({uiSettings:uiSettings});
}
},
updateIcon : function(data){
  if ( data.pawedpage== true) {
    chrome.browserAction.setIcon({path:"images/ext_icon/paw-icon-enabled.png"});
  } else {
    chrome.browserAction.setIcon({path:"images/ext_icon/paw-icon-disabled.png"});
  }
},
getDefaultAlbumImages:function(json_callback) {
  return new Promise((resolve, reject) => {
    resolve(wallpaperSettings.OnlineAlbumImages)
  });
},
getImageFile :function (imgurl,album) {
  return new Promise((resolve, reject) => {
    var fileNameIndex = imgurl.lastIndexOf("/") + 1;
    var filename = imgurl.substr(fileNameIndex);
    var filename= filename.split('.')[0];
    var xhr = new XMLHttpRequest(),
    blob;
    xhr.open("GET", imgurl, true);
    xhr.responseType = "blob";
    xhr.addEventListener("load", function () {
      if (xhr.status === 200) {
        logMode("Image retrieved");
                    // Blob as response
                    blob = xhr.response;
                    var obj={};
                    obj['blob']=blob;
                    obj['filename']=filename;
                    obj['location_txt']=album.location_txt;
                    obj['location_url']=album.location_url;
                    obj['artistname_txt']=album.artistname_txt;
                    obj['artistname_url']=album.artistname_url;
                    resolve(obj);
                    
                  }
                }, true);
            // Send XHR
            xhr.send();

          });

},
setDefaultAlbumImages:function(DefaultAlbumImages,db){
  return new Promise((resolve, reject) => {
    settingsObj
    .getSettings()
    .then(response => {
     myApp.uiSettings = response.uiSettings;
     var defaultAlbumImages=DefaultAlbumImages;
     var image_urls_arr = [];
     var promise_image_urls_arr = [];
     for (var i = 0; i < 10; i++) {
      var randomImage_key = myApp.randomIntFromInterval(0,(defaultAlbumImages.length-1));
      var randomImageObj = defaultAlbumImages[randomImage_key];
      var IMGURL = randomImageObj['image'];
      if (IMGURL!='') { 
        promise_image_urls_arr.push(
          myApp.getImageFile(IMGURL,randomImageObj).then((resData) => {
            image_urls_arr.push(resData);
          }) 
          .catch(error => {
            console.error("error", error);
          })
          );
      } 

    }
    Promise
    .all(promise_image_urls_arr)
    .then(() => {

      resolve(image_urls_arr)
    }); 

  })
    .catch(console.error);   
  });    
},
randomIntFromInterval:function(min,max) {
  return Math.floor(Math.random()*(max-min+1)+min);
},
getCookies:function(domain, name, callback) {
    chrome.cookies.get({"url": domain, "name": name}, function(cookie) {
        if(callback) {
          if (!!cookie) {
            callback(cookie.value);
          }else{
            callback('');
          }
        }
    });
},

newTabOnInstall:function(){
    var is_opened=false;
    chrome.tabs.query({}, function(tabs) {
     for (var i=0; i<tabs.length; ++i) {
        if (tabs[i].url === 'chrome://newtab/' ) {                    
            is_opened=true;
            chrome.tabs.update(
                tabs[i].id,
                {
                   url: 'chrome://newtab/?TRF=installed',"active": true,"highlighted":true
               }
               );
        }
    }
    if(is_opened==false ) {
        chrome.tabs.create({url:'chrome://newtab/?TRF=installed',"selected":true},function(tab){ });
    }
});
},

getAllblobData:function(blobData,db){
  return new Promise((resolve, reject) => {
    var readWriteMode = typeof IDBTransaction.READ_WRITE == "undefined" ? "readwrite" : IDBTransaction.READ_WRITE;
    var transaction = db.transaction(["IMAGES"], readWriteMode);
    //var objectStoreRequest = objectStore.delete(blobData.filename);
            // Put the blob into the dabase
            var put = transaction.objectStore("IMAGES").put(blobData.blob, blobData.filename);
            transaction.objectStore("IMAGES").get(blobData.filename).onsuccess = function (event) {
              var objBlob={};
              var imgFile = event.target.result;
                // Get window.URL object
                var URL = window.URL || window.webkitURL;

                // Create and revoke ObjectURL
                var imgURL = URL.createObjectURL(imgFile);
                objBlob[blobData.filename]=imgURL;
                resolve(objBlob);

              }


            });

},
};

function DeleteFromDB(remove_image_arr,db){
  settingsObj
  .getSettings()
  .then(response => {
    myApp.uiSettings = response.uiSettings;
    for (var k = 0; k < remove_image_arr.length; k++) {
      var thumbline=remove_image_arr[k];
      var readWriteMode = typeof IDBTransaction.READ_WRITE == "undefined" ? "readwrite" : IDBTransaction.READ_WRITE;
      var transaction = db.transaction(["IMAGES"], readWriteMode);
      var objectStore = transaction.objectStore("IMAGES");
      var request = objectStore.getAllKeys();
      var objectStoreRequest = objectStore.delete(thumbline);
      var AlbumBlobs=myApp.uiSettings.background_settings.choose_background_wallpaper.IMAGE_BLOBS;
      delete AlbumBlobs[thumbline];
      var selcted=myApp.uiSettings.background_settings.choose_background_wallpaper.IMAGE_SOURCE.title
      if (thumbline==selcted) {
        myApp.uiSettings.background_settings.choose_background_wallpaper.IMAGE_SOURCE['title']='';
      }
      myApp.uiSettings.background_settings.choose_background_wallpaper.IMAGE_BLOBS
      settingsObj
      .save({uiSettings: myApp.uiSettings})
      .then(response => {
       logMode(myApp.uiSettings.background_settings.choose_background_wallpaper.IMAGE_BLOBS)
     })
      
    }

  })
  .catch(console.error);
}

var bm_urls = new Array();

function sendMessage(tabId, msg){
  if(tabId) chrome.tabs.sendMessage(tabId, msg);
  else chrome.runtime.sendMessage(sender.id, msg);
}
function sendMessagePopup(sender,msg){
  chrome.runtime.sendMessage(sender.id, msg);
}


function getParameterByName(name, url = window.location.href) {
  name = name.replace(/[\[\]]/g, '\\$&');
  var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
  results = regex.exec(url);
  if (!results) return null;
  if (!results[2]) return '';
  return decodeURIComponent(results[2].replace(/\+/g, ' '));
}

function insert_uninstall_record(location){
  uiSettings.install_date = getDateTime();
  myApp.saveUISettings();
  var settings = {
    "url": "https://toprecipefinder.com/Api/api.php",
    "method": "POST",
    "timeout": 0,
    "headers": {
      "Content-Type": "application/x-www-form-urlencoded"
    },
    "data": {
      "product":'TopRecipeFinder',
      "location":location,
      "install_date": uiSettings.install_date,
      "uninstall_date": 'NA'
    }
  };

  $.ajax(settings).done(function (response) {
    console.log(response)
    var result = JSON.parse(response);
    if (result.success) {
      var last_id = result.last_id;
      uiSettings.user_Id=last_id;
      myApp.saveUISettings();
      var uninstall_url='https://toprecipefinder.com/uninstall.php?install_date='+uiSettings.install_date+'&uid='+last_id;
      chrome.runtime.setUninstallURL(uninstall_url, function(details){})
      

    }
  });

}

function getLocationForInstall(res){
  var location= res.country+', '+res.region+', '+res.city;
  insert_uninstall_record(location);
  var today_date = new Date();
  var current_time = today_date.getTime();
  uiSettings.last_get_location_time = current_time;
  uiSettings.location_obj = res;
  myApp.saveUISettings();
}

function setUninstallInsertInstall(){
  var today_date = new Date();
  var current_time = today_date.getTime();
  if (uiSettings.last_get_location_time == undefined) {
    uiSettings.last_get_location_time = current_time;
  }
  if (uiSettings.location_obj == undefined) {
    uiSettings.location_obj = {};
  }
  if (uiSettings.location_obj.city == undefined) {
    $.getJSON("https://ipinfo.io", function (res) {
     if (res!=undefined) {
      getLocationForInstall(res);
    }
  });
  } else {
    var res = uiSettings.location_obj;
    getLocationForInstall(res);
  }

}

function isDevMode() {
    return !('update_url' in chrome.runtime.getManifest());
}


$(document).ready(function(){

 chrome.runtime.onMessage.addListener(myApp.onExtMessage);
 myApp.load();

});

var db;
chrome.runtime.onInstalled.addListener(function(details){
  if(details.reason == "install"){
    var DevMode = isDevMode();
    if (!DevMode) {
      setUninstallInsertInstall();
    }else{
      var uninstall_url='https://toprecipefinder.com/uninstall.php?devmode='+DevMode;
      chrome.runtime.setUninstallURL(uninstall_url, function(details){})
    }
    myApp.newTabOnInstall();
    convertFunction('http://i.imgur.com/8MrOMt8.jpg', function(base64Img) {
      uiSettings.background_settings.choose_background_wallpaper.UPDATE_INTERVAL_first_img=base64Img;
      myApp.saveUISettings();
    });
    (function () {
    // IndexedDB
    var indexedDB = window.indexedDB || window.webkitIndexedDB || window.mozIndexedDB || window.OIndexedDB || window.msIndexedDB,
    IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction || window.OIDBTransaction || window.msIDBTransaction,
    dbVersion = 1.0;
    // Create/open database
    var request = indexedDB.open("mybookmark", dbVersion),
    createObjectStore = function (dataBase) {
      // Create an objectStore
      // logMode("Creating objectStore")
      dataBase.createObjectStore("IMAGES");
      //dataBase.createObjectStore("IMAGESOnline");
      let store = dataBase.createObjectStore('IMAGESOnline', {autoIncrement: true,keyPath: "id"});
      store.createIndex("uniqId", "id", { unique: false });
    };
    request.onsuccess = function (event) {
      db = request.result;
      if (event.type=='success' && db!=undefined) {
       CheckGit_Album_json_Update(db);
     } 

     db.onerror = function (event) {
       logMode("Error creating/accessing IndexedDB database");
     };
   }
   request.onupgradeneeded = function (event) {
    createObjectStore(event.target.result);
  };
})();
} else {
  // IndexedDB
  var indexedDB = window.indexedDB || window.webkitIndexedDB || window.mozIndexedDB || window.OIndexedDB || window.msIndexedDB,
  IDBTransaction = window.IDBTransaction || window.webkitIDBTransaction || window.OIDBTransaction || window.msIDBTransaction,
  dbVersion = 1.0;
  // Create/open database
  var request = indexedDB.open("mybookmark", dbVersion);
  request.onsuccess = function (event) {
    db = request.result;
    db.onerror = function (event) {
     logMode("Error creating/accessing IndexedDB database");
   };
 }
}
});

   function getDateTime() {
      var now     = new Date(); 
      var year    = now.getFullYear();
      var month   = now.getMonth()+1; 
      var day     = now.getDate();
      var hour    = now.getHours();
      var minute  = now.getMinutes();
      var second  = now.getSeconds(); 
      if(month.toString().length == 1) {
       month = '0'+month;
     }
     if(day.toString().length == 1) {
       day = '0'+day;
     }   
     if(hour.toString().length == 1) {
       hour = '0'+hour;
     }
     if(minute.toString().length == 1) {
       minute = '0'+minute;
     }
     if(second.toString().length == 1) {
       second = '0'+second;
     }   

     var dateTime = year+'-'+month+'-'+day+' '+hour+':'+minute+':'+second;   
     return dateTime;
   }
   
function CheckGit_Album_json_Update(db){
 return new Promise((resolve, reject) => {
  myApp.getDefaultAlbumImages().then((resJson) => {
    var DefaultAlbumImages = resJson;
    uiSettings.online_wallpapers=DefaultAlbumImages;
    myApp.saveUISettings();
    myApp.setDefaultAlbumImages(DefaultAlbumImages,db).then((res) => {
      addOnlineAlbumsToDb(db,res);
    })
  })
})
 .catch(error => {
  console.error("error", error);
});

}

function databaseExists(dbname) {
  var req = indexedDB.open(dbname);
  var existed = true;
  req.onsuccess = function () {
    var db=req.result;
    return db;

  }

}

function removeDuplicateUsingFilter(arr){
  let unique_array = arr.filter(function(elem, index, self) {
    return index == self.indexOf(elem);
  });
  return unique_array
}

var ParentIds={};
function logMode(message) {
  if (debug) { 
    console.log(message);
  }
}

/*chrome.management.getSelf( (o)=>{
   myApp.uiSettings = uiSettings;
   if (o.installType === "development") {
    myApp.uiSettings['Log_Flag']= true;
  }
  myApp.uiSettings['extension_version']= o.version;
  myApp.saveUISettings();
  debug = myApp.uiSettings.Log_Flag;

});*/


chrome.browserAction.onClicked.addListener(function(tab) {
    chrome.tabs.create({"url": "html/home.html"});

});


function convertFunction(url, callback) {
  var xhr = new XMLHttpRequest();
  xhr.onload = function() {
    var reader = new FileReader();
    reader.onloadend = function() {
      callback(reader.result);
    }
    reader.readAsDataURL(xhr.response);
  };
  xhr.open('GET', url);
  xhr.responseType = 'blob';
  xhr.send();
}



function addOnlineAlbumsToDb(db, datares) {
  const tx = db.transaction(["IMAGESOnline"], "readwrite");
  datares.forEach(data => {
    let onlineImages = {artistname_txt: data.artistname_txt,artistname_url: data.artistname_url,blob: data.blob,filename: data.filename,location_txt: data.location_txt,location_url: data.location_url, };
    let request = tx.objectStore("IMAGESOnline").add(onlineImages);
  })
  tx.oncomplete = function(event) {
    console.log('add multiple')
  }
};

function deleteoldKeysDb() {
  settingsObj
  .getSettings().then(response => {
   myApp.uiSettings = response.uiSettings;
   var lastKey=myApp.uiSettings.background_settings.choose_background_wallpaper.UPDATE_INTERVAL_last_img;
   var req = indexedDB.open('mybookmark');
   req.onsuccess = function () {
    var db=req.result;
    var readWriteMode = typeof IDBTransaction.READ_WRITE == "undefined" ? "readwrite" : IDBTransaction.READ_WRITE;
    var transaction = db.transaction(["IMAGESOnline"], readWriteMode);
    var objectStore = transaction.objectStore("IMAGESOnline");
    var request = objectStore.getAllKeys();
    request.onsuccess = function(event) {
      var new_obj=[];
      var allkeys=event.srcElement.result;
      for (let key in allkeys) {
        if (allkeys[key]!=lastKey) {
          new_obj.push(allkeys[key]  )
        }

      }
      const tx = db.transaction(["IMAGESOnline"], "readwrite");
      new_obj.forEach(data => {
        let request = tx.objectStore("IMAGESOnline").delete(data);
      })

      tx.oncomplete = function(event) {
        console.log('delete multiple')
        CheckGit_Album_json_Update(db);
      }

    };

  }
})
  .catch(console.error);

};

/*chrome.alarms.clear(chrome.runtime.getManifest().name+'_alarmOnlineAlbum', function(){
  chrome.alarms.create(chrome.runtime.getManifest().name+'_alarmOnlineAlbum', {
    delayInMinutes :40,
    periodInMinutes: 40
  });
});

chrome.alarms.onAlarm.addListener(function(alarm) {    
  if (alarm.name == chrome.runtime.getManifest().name+'_alarmOnlineAlbum') {
   deleteoldKeysDb();
 }
});*/

 

 