var uiSettings={};
function getParameterByName(name, url = window.location.href) {
	name = name.replace(/[\[\]]/g, '\\$&');
	var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
	results = regex.exec(url);
	if (!results) return null;
	if (!results[2]) return '';
	return decodeURIComponent(results[2].replace(/\+/g, ' '));
}
function nl2br(str){
	return str.replace(/(?:\r\n|\r|\n)/g, '<br>');
}

function checkValidateLastrecipe(last_update_time){
	if (last_update_time != undefined && last_update_time !='' ) {
		var currentTime = new Date().getTime();
		if (currentTime - last_update_time >= 1*24*60*60*1000 ) {
			return true;
		}else{
			return false;
		}

	}else{
		return true
	}
}

var title = getParameterByName('recipe');
var weburl= getParameterByName('weburl');
var isUpdateNow= getParameterByName('isUpdateNow');
var index= getParameterByName('index');

settingsObj
.getSettings()
.then(getSettings => {
	uiSettings = getSettings.uiSettings;
	var recipes_arr=uiSettings.recipes_arr;
	var resJsonStr = recipes_arr[index]['detail_json'];
	var last_update_time = recipes_arr[index]['last_update'];
	var isUpdateNow = checkValidateLastrecipe(last_update_time);
	if (isUpdateNow) {
		$('.loading-overlay').show();
		getRecipeFromTitle().then((resJson) => {
			uiSettings.recipes_arr[index]['detail_json']=JSON.stringify(resJson);
			uiSettings.recipes_arr[index]['last_update']=new Date().getTime();
			settingsObj
			.save({uiSettings: uiSettings})
			.then(saveResponse => {
				createRecipeBox(resJson)
			})
			.catch(console.error);
			
		})
	}else{
		var resJson=JSON.parse(resJsonStr);
		createRecipeBox(resJson)
	}

})
.catch(console.error);



function createRecipeBox(response){

				console.log(response);
				var rating = response['ReviewCount'];
				var cat = response['Category'];
				var thumb=response['PhotoUrl'];
				var Title = response['Title'];

				var last = thumb.substring(thumb.lastIndexOf("/") + 1, thumb.length);
				var src='https://bigoven-res.cloudinary.com/image/upload/w_300,c_fill,h_250/'+last;

				$('#Recipe').find('.rcp__img_sz').find('img').attr('src',src);
				$('#Recipe').find('.recipe_title').html(!!(Title)?Title:'')
				$('#title-in').html(!!(Title)?Title:'')

				if (!!(cat)) {
					$('#sub-cat-div').show();
					$('#Recipe').find('#recipe-sub-cat').html(!!(cat)?cat:'')
				}else{
					$('#sub-cat-div').hide();
				}
				var StarRating = !!(rating)?rating:0;
				var rating_html='';
				for (var i = 1; i < 6; i++) {
					if (StarRating >= i) {
						rating_html+=`<i class="fas fa-star"></i>`;     
					}else{
						rating_html+=`<i class="fas fa-star clr-grey"></i>`;
					}
				}  
				$('.recipe_rating').html(rating_html);
				$('#mor-word').text(title);
				New_weburl= weburl + ` recipes`;
				$('#redirect-link a').attr('href',New_weburl);

				var summery = !!(response.Description)?response.Description:''
				summery= nl2br(summery);
				var max100 = summery.substr(0,150);
				var maxAll = summery.substr(150,summery.length);
				$('#recipe_description').find('#max-100').html(max100);
				$('#recipe_description').find('#max-all').html(maxAll);
				if (summery.length==0 && summery == '') {
					$('#summery-div').hide()
				}
				if (summery.length > 150 ) {
					$('#recipe_description').find('.read-more-trigger').show();
				}else{
					$('#recipe_description').find('.read-more-trigger').hide(); 
				}

				var Instructions = !!(response.Instructions)?response.Instructions:'';

				Instructions= nl2br(Instructions);
				var max100 = Instructions.substr(0,150);
				var maxAll = Instructions.substr(150,Instructions.length);
				$('#instruction_description').find('#ins-100').html(max100);
				$('#instruction_description').find('#ins-all').html(maxAll);

				if (Instructions.length > 150 ) {
					$('#instruction_description').find('.read-more-trigger').show();
				}else{
					$('#instruction_description').find('.read-more-trigger').hide(); 
				}

		//$('#Recipe').find('#recipe_description').html(!!(response.Description)?response.Description:'')
		var minutes = !!(response.TotalMinutes)?response.TotalMinutes:'';
		var totalminutes = "NA";
		var _format = "Minutes";
		if (minutes != '' && minutes >= 60) {
			var totalminutes = Math.floor(minutes / 60); 
			var _format = "Hour";         
		}else{
			var totalminutes=minutes;
		}
		if (totalminutes != '') {
			$('#_format').text(_format);
		}else{
			var totalminutes = "NA";
		}

		$('#Recipe').find('#recipe_time').html(totalminutes);


		var ingredient=response.Ingredients;
		if (ingredient.length !=0) {
			var ingredient_table = $('#ingredient-table')
			var ingredient_table_html='';
			for (var i = 0; i < ingredient.length; i++) {
				var name = ingredient[i]['Name'];
				var unit=ingredient[i]['Unit']!=null ? ingredient[i]['Unit']:'';
				var Quantity=ingredient[i]['DisplayQuantity']!=null ? ingredient[i]['DisplayQuantity']:'';
				Quantity = Quantity+' '+unit;
				/*ingredient_table_html+= `<tr>
				<td>`+Quantity+`</td>
				<td>`+name+`</td>
				</tr>`;*/
				ingredient_table_html+= `<a href="#" class="list-group-item list-group-item-action">`+Quantity+`&nbsp;`+name+`</a>`

			}
			if (ingredient_table_html !='') {
				$(ingredient_table).html(ingredient_table_html)
			}
			$('#ing-loader').hide();
			$('#ing-table-box').show();
		}

		$('.table.myTable').show();
		$('.loading-overlay').hide();
		$('#Recipe').show();
	
}

function getRecipeFromTitle(json_callback) {
	return new Promise((resolve, reject) => {
		var settings = {
			"url":``+consts.oven_api_url+`?pg=1&rpp=100&title_kw=`+title+`&api_key=`+consts.oven_api_key ,
			"method": "GET",
			"timeout": 0
			
		};

		$.ajax(settings).done(function (response) {
			var Results = response.Results
			var newRecipesArray = [];
			for (var i = 0; i < Results.length; i++) {
				if (Results[i]['PhotoUrl'].indexOf('recipe-no-image')==-1) {
					var obj={'RecipeID':Results[i]['RecipeID'],'PhotoUrl':Results[i]['PhotoUrl'],'Category':Results[i]['Category'],'ReviewCount':Results[i]['ReviewCount'],'Title':Results[i]['Title']}
					newRecipesArray.push(obj);
				}
			}

			var uniqRecipe = newRecipesArray[Math.floor(Math.random()*newRecipesArray.length)];
			var RecipeID=uniqRecipe['RecipeID'];


			var settings = {
				"url": "https://api2.bigoven.com/recipe/"+RecipeID+"?api_key=gr5675tyP8w49I1HtY3M0P0ig9X3Zvh0",
				"method": "GET",
				"timeout": 0,
			};

			$.ajax(settings).done(function (response) {
				resolve(response)
			})
			.fail(function(){
				var error=`<div class="loading-overlay is-active" style="display: inline-flex;"><h3>
				<span class="text-danger">Something Went Wrong! Please try again.</span></h3>
				</div>`;

				$('.loading-overlay').hide().after(error);

			})
			
		})
.fail(function(){
	var error=`<div class="loading-overlay is-active" style="display: inline-flex;"><h3>
	<span class="text-danger">Something Went Wrong! Please try again.</span></h3>
	</div>`;

	$('.loading-overlay').hide().after(error);

})
});
}


$('#list_search').hover(function () {
	$('.my-Search_btn').addClass('my-Search_btn_hover'); 
}, 
function () {
	$('.my-Search_btn').removeClass('my-Search_btn_hover'); 

} 
) 

var callback = null;
function sendMessage(msg, callbackfn) {
	if(callbackfn!=null) {
		msg.callback = "yes";
	}
	chrome.runtime.sendMessage(msg,callbackfn);
}