window.addEventListener("load",function() {
  chrome.runtime.onMessage.addListener(handleMessage);
  myKeepSettingPage.load();
});
var is_started_tour=false;
var uiSettings;
var myKeepSettingPage = {
  uiSettings: {},
  load: function(){ 
    myKeepSettingPage.addEvents();

    settingsObj
    .getSettings()
    .then(response => {
      myKeepSettingPage.uiSettings = response.uiSettings;
   
      var show_keep_setting_popup = myKeepSettingPage.uiSettings.show_keep_setting_popup;

      var show_security_popup = myKeepSettingPage.uiSettings.show_security_popup;

      var show_guide_popup = myKeepSettingPage.uiSettings.show_guide_popup;

      /*var show_sp1_popup = myKeepSettingPage.uiSettings.show_sp1_popup;

      var show_sp2_popup = myKeepSettingPage.uiSettings.show_sp2_popup;

      var show_converter_boxes = myKeepSettingPage.uiSettings.show_converter_boxes;*/

      var TRF = getParameterByName('TRF');

      if (show_keep_setting_popup == true && TRF != undefined && TRF == 'installed' ) {
        $(".mfc-keep-settings-section").show();
        //setIframePopupSecurity(true);
        setTimeout(function(){
          $("#mfc-section-overlay").addClass("fade-out");
          setTimeout(function(){
           myKeepSettingPage.saveKeepSetting();
         }, 800);
        }, 6000);
      }
      if (show_security_popup==true && !show_keep_setting_popup && TRF != undefined && TRF == 'installed') {
        //setIframePopupSecurity(false);
      }
      if (show_guide_popup == true && !show_keep_setting_popup && !show_security_popup) {
        myKeepSettingPage.startTour();
      }
      
    })
    .catch(console.error);
  },
  addEvents: function(){
    $(document).on('click', '.mfc-keep-settings-backdrop-section', function(e){
      e.preventDefault();
      myKeepSettingPage.saveKeepSetting();
    });
  },
  startTour:function(){

    var tourguide = new Tourguide({
      onStart:function(options){
        console.log(options)
       $('.guided-tour-step-first').find('.guided-tour-step-highlight').css('visibility','hidden');
        $('.guided-tour-step-first').addClass('bg-grey');
      },
      onStop:function(options){
        homePageObj.saveTourStatus();
      },
      onComplete:function(options){
        homePageObj.saveTourStatus();
      },
      onStep:function(currentstep, type){
      $('.guided-tour-step-first').removeClass('bg-grey');
      if (currentstep.title =="Daily Recipes") {
        $('.guided-tour-step:eq(1)').find('.guided-tour-step-highlight').css('visibility','hidden');
        $('.guided-tour-step:eq(1)').addClass('bg-grey');
      }
      },
      onAction:function(currentstep, e){
        console.log(currentstep)
      }
    });
    tourguide.start();
    
  },
  saveKeepSetting: function(){
    settingsObj
    .getSettings()
    .then(response => {
      myKeepSettingPage.uiSettings = response.uiSettings;
      myKeepSettingPage.uiSettings.show_keep_setting_popup = false;
      settingsObj.save({uiSettings : myKeepSettingPage.uiSettings});
      $(".mfc-keep-settings-section").hide();
      var is_tour_active = myKeepSettingPage.uiSettings.is_tour_active;
      if (is_tour_active==true && !is_started_tour) {
        is_started_tour = true;
       setIframePopupSecurity();
      }
    })
    .catch(console.error);
  }
};

var callback=[];
function sendMessage(msg, callbackfn) {
  if(callbackfn!=null) {
    callback.push(callbackfn);
    msg.callback = "yes";
  }
  chrome.runtime.sendMessage(msg,callbackfn);
}

function getParameterByName(name, url = window.location.href) {
  name = name.replace(/[\[\]]/g, '\\$&');
  var regex = new RegExp('[?&]' + name + '(=([^&#]*)|&|#|$)'),
  results = regex.exec(url);
  if (!results) return null;
  if (!results[2]) return '';
  return decodeURIComponent(results[2].replace(/\+/g, ' '));
}


function handleMessage(message, sender) {
  switch (message.command) {
    case "rec_getSettings":
    myKeepSettingPage.uiSettings  = message.data.uiSettings;
    myKeepSettingPage.smsSettings = message.data.smsSettings;
    break;
  }
  if(typeof(message.data)!="undefined") {
    if(typeof(message.callback)!="undefined" && message.callback=="yes") {
      var fun = callback.pop();
    }
  }
}