(function() {

    function getCaller(method) {
        return function() {
            let args = Array.prototype.slice.apply(arguments);
            return new Promise((resolve, reject) => {
                let port = chrome.runtime.connect({"name": "settingsObj"});
                port.onMessage.addListener(msg => {
                    resolve.apply(null, msg.arguments);
                    port.disconnect();
                });
                port.postMessage({"target":"settingsObj","method":method,"arguments":args});
            });
        }
    }
    function createObjectWithCallers(endpoints) {
        let obj = {};
        endpoints.forEach(endpoint => obj[endpoint] = getCaller(endpoint));
        return obj;
    }
    window.settingsObj = createObjectWithCallers(["getSettings", "save"]);
})();