(function() {
    let cache = null; // here we store uiSettings object
    const settingsObj = {
        "getSettings": function(resetCache) {
            return new Promise((resolve, reject) => {
                try {
                    /*if (cache === null || resetCache) {
                    }*/
                        cache = JSON.parse(localStorage['uiSettings']);
                    resolve({"uiSettings": Object.assign({}, cache)});
                } catch (err) {
                    reject(err);
                }
            });
        },
        "save": function(settings) {
            return new Promise((resolve, reject) => {
                try {
                    localStorage["uiSettings"] = JSON.stringify(settings.uiSettings);
                    cache = Object.assign({}, settings.uiSettings);
                    resolve({uiSettings: Object.assign({}, cache)});
                } catch (err) {
                    reject(err);
                }
            });
        }
    };

    function onConnectHandler(port) {
        if (port.name !== "settingsObj") return;
        function onMessageHandler(msg) {
            if (settingsObj.hasOwnProperty(msg.method)) {
                let res;
                if (msg.arguments instanceof Array) {
                    res = settingsObj[msg.method].apply(null, msg.arguments);
                } else {
                    res = settingsObj[msg.method].apply(null);
                }
                res.then(function() {
                    let args = Array.prototype.slice.apply(arguments);
                    port.postMessage({"arguments":args});
                });
            }
        }
        port.onMessage.addListener(onMessageHandler);
    }

    chrome.runtime.onConnect.addListener(onConnectHandler);

    window.settingsObj = settingsObj;
})();