
var Weather = function() {
}
var global_weather_unit = "C";

Weather.prototype.setDate = function() {
  var d = new Date();
  var n = d.toDateString(); 
  $("#date").text(n);
};

Weather.prototype.getLocation = function() {
  var _this = this;
  //debugger;
  settingsObj
  .getSettings()
  .then(response => {
    var uiSettings = response.uiSettings;
    var today_date = new Date();
    var current_time = today_date.getTime();
    if (uiSettings.last_get_location_time == undefined) {
      uiSettings.last_get_location_time = current_time;
    }
    if (uiSettings.location_obj == undefined) {
      uiSettings.location_obj = {};
    }
    var last_location_time = uiSettings.last_get_location_time;    
    var count_hour = Math.abs(current_time - last_location_time) / 36e5;
    /* Call api in 24 hour once */
    if (count_hour >= 24 || uiSettings.location_obj.city == undefined) {
      $.getJSON("https://ipinfo.io", function (res) {
       settingsObj
       .getSettings()
       .then(response => {
        var uiSettings = response.uiSettings;
        var today_date = new Date();
        var current_time = today_date.getTime();
        uiSettings.last_get_location_time = current_time;
        uiSettings.location_obj = res;
        settingsObj
        .save({uiSettings: uiSettings})
        .then(saveResponse => {
          console.log(saveResponse.uiSettings)
          $("#current-location").text( res.city + ", " + res.country);
          $("#city-name").text(res.city);
          _this.location = res.city + ", " + res.country;
          _this.currentWeather();
          _this.forecast();  
        }).catch(console.error);
      })
     });
    } else {
      var res = uiSettings.location_obj;
      $("#current-location").text( res.city + ", " + res.country);
      $("#city-name").text(res.city);
      _this.location = res.city + ", " + res.country;
      _this.currentWeather();
      _this.forecast();
    }
  });
};

Weather.prototype.setLocation = function() {
    //set location from input text
    $("#f_locator").on("submit", (function(e){
      e.preventDefault();
      this.location = $("#location").val();
      this.currentWeather();
      this.forecast();
      this.loadAnimation();
    }).bind(this) );
  };

  Weather.prototype.getWeatherIcon = function(wId, sunrise, sunset) {
    //get weather icon passing returned ID of openweather API. Optional sunrise and sunset time, to determine if is day or night type icon. Return an object with icon name and icon animation properties.
    if(wId) {
      var icon={};
      icon.name = "na";
      icon.animation = "wi-scale";

      function between(min, max, group, animation) {
        if (wId >= min && wId < max) {
          icon.name = group ? group : "na";
          icon.animation = animation ? animation : "wi-scale";
        }
      }

      between(200, 300, "thunderstorm", "wi-fade");
      between(300, 400, "showers", "wi-moveY");
      between(500, 600, "rain", "wi-moveY");
      between(600, 700, "snow", "wi-moveY");
      between(700, 800, "na", "wi-fade");
      between(801, 900, "cloudy", "wi-moveX");
      between(900, 1000, "na");

      var cond = {
        200: "storm-showers",
        201: "storm-showers",
        202: "thunderstorm",
        500: "rain-mix",
        501: "rain-mix",
        502: "rain",
        511: "sleet",
        520: "rain-mix",
        521: "rain-mix",
        600: "snow",
        611: "sleet",
        701: "fog",
        741: "fog",
        905: "windy",
        906: "hail",
      };

      var neutralCond = {
        711: "smoke",
        731: "sandstorm",
        761: "dust",
        762: "volcano",
        781: "tornado",
        900: "tornado",
        902: "hurricane",
        903: "snowflake-cold",
        904: "hot",
        958: "gale-warning",
        959: "gale-warning",
        960: "storm-warning",
        961: "storm-warning",
        962: "hurricane"
      };
      var dayCond = {
        721: "haze",
        800: "sunny"
      };
      var nightCond = {
        800: "clear",
        701: "fog",
        741: "fog"
      };
      
      icon.name = cond[wId] ? cond[wId] : icon.name;
      icon.name = neutralCond[wId] ? neutralCond[wId] : icon.name;
      icon.name = dayCond[wId] ? dayCond[wId] : icon.name;
      var time = "day";
      if (sunrise && sunset) {
        var now = Date.now()/1000;
        var srDate = new Date(sunrise*1000);
        if (srDate.getDate() == new Date().getDate()) {
          if (now <= sunrise && now >= sunset) {
            time = nightCond[wId] ? "night" : "night-alt";
            icon.name = nightCond[wId] ? nightCond[wId] : icon.name;
          }
        } else {
          time = nightCond[wId] ? "night" : "night-alt";
          icon.name = nightCond[wId] ? nightCond[wId] : icon.name;
        }
      }
      if (icon.name != "na" && !neutralCond[wId]) {
        icon.name = "wi-"+time+"-"+icon.name;
      } else {
        icon.name = "wi-"+icon.name;
      }
      icon.animation = icon.name == "wi-day-sunny" ? "wi-rotate" : icon.animation;
      return icon;
    }
  }; //end getWeatherIcon

  Weather.prototype.displayWeatherIcon = function(selector, icon) {
    //display weather icon. first arg is where to display. Second arg is what returned from getWeatherIcon method.
    if (selector && typeof icon == "object") {
      if (icon.name != "na") {
        $(selector).addClass(icon.name);
        animate(selector, icon.animation, 2000, 0, "linear", "infinite");
      }
    }
  };

  Weather.prototype.currentWeather = function() {
    //get current weather from openweather API, format, and display it.
    if (this.location) {

      function setMainWeather(res) {
        if (res.main) {

          settingsObj
          .getSettings()
          .then(response => {
            var uiSettings = response.uiSettings;
            var weather_unit = uiSettings.weather_unit || "C";
            var temp_current = Math.round(res.main.temp);
            var newUnit = weather_unit;
            console.log("newUnit >> ", newUnit);
            console.log("temp_current >> ", temp_current);
            if (newUnit == "F") {
              var temp_new = Math.round( (temp_current * 1.8 ) + 32 );
            } else {
              var temp_new = Math.round(temp_current);
            }

            if (newUnit == "F") {
              var temp_new_max = Math.round( (res.main.temp_max * 1.8 ) + 32 );
            } else {
              var temp_new_max = Math.round(res.main.temp_max);
            }
            
            if (newUnit == "F") {
              var temp_new_min = Math.round( (res.main.temp_min * 1.8 ) + 32 );
            } else {
              var temp_new_min = Math.round(res.main.temp_min);
            }
            $(".city-temperature").text(temp_new+"°"+weather_unit);
            $("#temperature-w").text(temp_new+"°"+weather_unit);
            $("#description").text(res.weather[0].description);
            $("#temp-h-l").html('High <span class="-max-temp">'+temp_new_max+'°'+weather_unit+' </span>| '+'Low <span class="-min-temp">'+temp_new_min+'°'+weather_unit+'</span>');
            $("#wind-cond-w").html('<span>Wind: '+Math.round(res.wind.speed)+"mph"+'</span>');
            if (res.main.humidity) {
              $("#humidity").text(res.main.humidity);
            } else {
              $("#humidity").text("0");
            }
          });

        }
      }

      /* Call openweathermap api */
      var this_1 = this;
      settingsObj
      .getSettings()
      .then(response => {
        var uiSettings = response.uiSettings;
        var today_date = new Date();
        var current_time = today_date.getTime();
        if (uiSettings.last_get_weather_time == undefined) {
          uiSettings.last_get_weather_time = current_time;
        }
        if (uiSettings.weather_obj == undefined) {
          uiSettings.weather_obj = {};
        }
        var last_weather_time = uiSettings.last_get_weather_time;        
        var count_hour = Math.abs(current_time - last_weather_time) / 36e5;

        if (count_hour >= 1 || uiSettings.weather_obj.weather == undefined) {
          $.getJSON("https://api.openweathermap.org/data/2.5/weather",{q: this_1.location, units: "metric", appid: consts.weatherApiKey}, (function(json) {
            var wId = json.weather[0].id;
            if(wId) {
              var icon = this.getWeatherIcon(wId, json.sys.sunrise, json.sys.sunset);
              this.displayWeatherIcon("#wicon-main",icon);
              this.displayWeatherIcon("#home-page-wicon-main",icon);
            }
            setMainWeather(json);
            settingsObj
            .getSettings()
            .then(response => {
              var uiSettings = response.uiSettings;
              var today_date = new Date();
              var current_time = today_date.getTime();
              uiSettings.last_get_weather_time = current_time;
              uiSettings.weather_obj = json;
              settingsObj
              .save({uiSettings: uiSettings})
              .then(saveResponse => {
                console.log(saveResponse.uiSettings)
              }).catch(console.error);
            })
            }).bind(this_1) );
        } else {
          var json = uiSettings.weather_obj;
          var wId = json.weather[0].id;
          if(wId) {
            var icon = this_1.getWeatherIcon(wId, json.sys.sunrise, json.sys.sunset);
            this_1.displayWeatherIcon("#wicon-main",icon);
            this_1.displayWeatherIcon("#home-page-wicon-main",icon);
          }
          setMainWeather(json);
        }

      }).catch(console.error);
        }
      }; 

      Weather.prototype.forecast = function() {    
      //get forecast (5 days) weather from openweather API, format, and display it.

      _this = this;
      settingsObj
      .getSettings()
      .then(response => {
        var uiSettings = response.uiSettings;
        var today_date = new Date();
        var current_time_forecast = today_date.getTime();
        if (uiSettings.last_get_location_time_forecast == undefined) {
          uiSettings.last_get_location_time_forecast = current_time_forecast;
        }

        var last_location_time = uiSettings.last_get_location_time_forecast;    
        var count_minutes = Math.abs(current_time_forecast - last_location_time) / 1000;
        var minutes = Math.floor(count_minutes / 60) % 60;
        /* Call api in 10 minutes once */
        if (minutes >= 10 || uiSettings.weather_forecast_obj == undefined) {
          $.getJSON("https://api.openweathermap.org/data/2.5/forecast/daily",{q: _this.location, cnt: 5, units: "metric", appid: consts.weatherApiKey}, (function(json) {
            setForecast.call(_this,json);
            displayForecast.call(_this);
            settingsObj
            .getSettings()
            .then(response => {
              var uiSettings = response.uiSettings;
              uiSettings.last_get_location_time_forecast = current_time_forecast;
              uiSettings.weather_forecast_obj = json;
              settingsObj
              .save({uiSettings: uiSettings})
              .then(saveResponse => {
                 console.log(saveResponse.uiSettings)
              }).catch(console.error);

            })

          }).bind(_this) ); 


        } else {
          var res = uiSettings.weather_forecast_obj;
          setForecast.call(_this,res);
          displayForecast.call(_this);
        }
        
        function setForecast(res) {


          $(".loading").fadeOut();
          $("#main").css("opacity",1);
          loadTooltips();
          animate(".days-box", "scale", 400, 500, "ease-out");
          var delayAnim = 1300;
          $(".days-box").children(".col-xs-3").each(function() {
            animate(this, "fadeIn", 350, delayAnim, "ease-out");
            delayAnim += 350;
          });

          this.daily=[];
          var list = res.list;
          for (var i = 1, len = list.length; i < len; i++) {
            this.daily[i] = this.daily[i] ? this.daily[i] : {};
            this.daily[i].maxTemp = Math.round(list[i].temp.max);
            this.daily[i].minTemp = Math.round(list[i].temp.min);
            this.daily[i].humidity = Math.round(list[i].humidity);
            this.daily[i].day = new Date(list[i].dt*1000).getDay();
            var iconId = list[i].weather[0].id;
            this.daily[i].icon = this.getWeatherIcon(iconId);
          }
        }
        function displayForecast() {      
          var days = ["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],
          _this = this;
          $(".days-box").children(".col-sm-3").each(function(index) {
            var _index=parseInt(index+1);
          //$(this).attr('data-original-title',_this.daily[_index].humidity)
          $(this).children('.day').text(days[_this.daily[_index].day]);

          var newUnit = global_weather_unit;
          console.log("displayForecast()  newUnit >> ", newUnit);          
          if (newUnit == "F") {
            var temp_daily_new_min = Math.round( (_this.daily[_index].minTemp * 1.8 ) + 32 );
          } else {
            var temp_daily_new_min = Math.round(_this.daily[_index].minTemp);
          }
          if (newUnit == "F") {
            var temp_daily_new_max = Math.round( (_this.daily[_index].maxTemp * 1.8 ) + 32 );
          } else {
            var temp_daily_new_max = Math.round(_this.daily[_index].maxTemp);
          }

          $(this).find('.d-min-temp').text(temp_daily_new_min+"°"+global_weather_unit);
          $(this).find('.d-max-temp').text(temp_daily_new_max+"°"+global_weather_unit);
          $(this).find('.wi').addClass(_this.daily[_index].icon.name);
        });      
        }


      });


    };

    Weather.prototype.setUnit = function() {
      //Switch between Celsius and Farhenheit
      settingsObj
      .getSettings()
      .then(response => {
        var uiSettings = response.uiSettings;
        var prevUnit = uiSettings.weather_unit || "C";
        $("#unit-switch").on("click", function() {
          var newUnit = prevUnit == "C" ? "F" : "C";
          weather.setWeatherUnits(newUnit);
          settingsObj
          .getSettings()
          .then(response => {
            var uiSettings = response.uiSettings;
            var weather_unit = newUnit;
            uiSettings.weather_unit = weather_unit;
            settingsObj
            .save({uiSettings: uiSettings})
            .then(saveResponse => {
              prevUnit = newUnit;
            })
            .catch(console.error);

          })
          .catch(console.error);
          
          
        });


      })
      .catch(console.error);      
    }

    Weather.prototype.setWeatherUnits = function(newUnit) {      
      $("span:contains('°')").each(function(index, el) {
        $(el).text().replace( /[^\d.]/g, '' )
        var temp_current = parseFloat($(el).text());
        console.log('temp_current >> ', temp_current);
        if (newUnit == "F") {
          var temp_new = Math.round( (temp_current * 1.8 ) + 32 );
        } else if (newUnit == "C") {
          var temp_new = Math.round( (temp_current - 32) / 1.8 );
        }
        $(el).text(temp_new+"°" + newUnit);
        animate(el, "fadeIn", 400, 0, "ease-out");
      });
    }

    Weather.prototype.loadAnimation = function() {
      $(".loading").css("display","block");
      $("#main").css("opacity",0);
      /*var countAjax = 0;
      $(document).ajaxComplete(function() {
        countAjax++;
        if(countAjax == 2){
          $(".loading").fadeOut();
          $("#main").css("opacity",1);
          loadTooltips();
          animate(".days-box", "scale", 400, 500, "ease-out");
          var delayAnim = 1300;
          $(".days-box").children(".col-xs-3").each(function() {
            animate(this, "fadeIn", 350, delayAnim, "ease-out");
            delayAnim += 350;
          });
        }
      });*/
    }

  //Animation using CSS @keyframes
  function animate (selector, keyFrameName, duration, delay=0, timing="ease", iteration=1) {
    //jQuery selector; CSS keyframes name; duration in ms; delay in ms;
    $(selector).css({"visibility": "hidden"});
    setTimeout(
      function () {
        $(selector).css({"visibility": "visible"});
        $(selector).css({"animation": keyFrameName+" "+duration+"ms "+timing+" "+iteration});
      }, delay
      );
    if (iteration != "infinite") {
      setTimeout(
        function () {
          $(selector).css({"animation": ""});
        }, (delay+duration)*iteration
        );
    }
  };
  /* https://codepen.io/sinapsis7 */
  function loadTooltips() {
    //search for elements that have data-tooltips attributes on the web page, and display it.
    $("[data-tooltip]").each(function() {
      var tag = $(this)[0].tagName.toLowerCase();
      var tooltip = $(this).attr("data-tooltip");
      var tooltipParentH = $(this).outerHeight();
      var parentPosition = $(this).position();
      $(tooltip).insertAfter(this);
      $(tooltip).css({"max-width": document.body.clientWidth-parentPosition.left-5+"px", "transition": "opacity 0.3s"});
      
      function showTooltip() {
        $(tooltip).css({"visibility": "visible", "opacity": 1, "top": parentPosition.top+tooltipParentH+10+"px", "left": parentPosition.left+"px"});
      }
      function hideTooltip() {
        $(tooltip).on("mouseenter", stoptimerHide);
        function stoptimerHide() {
          clearTimeout(timerHide);
          $(tooltip).on("mouseleave", hideTooltip);
        }
        var timerHide = setTimeout(function(){
          $(tooltip).css({"visibility": "hidden", "opacity": 0});
        }, 100);
      }
      
      var _this = $(this);
      if (tag == "input") {
        $(this).on("focus", function() {
          showTooltip();
          _this.off("mouseleave", hideTooltip);
        });
        $(this).on("blur", function() {
          hideTooltip();
          _this.on("mouseleave", hideTooltip);
        });
        $(this).on("mouseenter", showTooltip);
        $(this).on("mouseleave", hideTooltip);
      } else {
        $(this).on("mouseenter", showTooltip);
        $(this).on("mouseleave", hideTooltip);
      }
    });
  }

  //Run
  var weather = new Weather();
  $(document).ready( function () {
    /*Set saved weather unit */
    settingsObj
    .getSettings()
    .then(response => {
      var uiSettings = response.uiSettings;
      global_weather_unit = uiSettings.weather_unit || "C";
      uiSettings.weather_unit = global_weather_unit;
      settingsObj
      .save({uiSettings: uiSettings})
      .then(saveResponse => {

      })
      .catch(console.error);
      
      if (global_weather_unit == "C") {
        $("#unit-switch").prop('checked', true);
      } else {
        $("#unit-switch").prop('checked', false);        
      }

      weather.loadAnimation();
      weather.setDate();
      weather.getLocation();
      weather.setLocation();
      weather.setUnit();

    })
    .catch(console.error);

  });
